<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of LiTraAk Plugin for Dotclear 2.
# 
# Copyright (c) 2008 Akewea.com
# 
# LiTraAk Plugin for Dotclear 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# LiTraAk Plugin for Dotclear 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with LiTraAk Plugin for Dotclear 2.  If not, see <http://www.gnu.org/licenses/>.
#
# -- END LICENSE BLOCK ------------------------------------

class litraakExtProject extends rsExtPost
{
	public static function countMedia(&$rs)
	{
		if (isset($rs->_nb_media[$rs->index()]))
		{
			return $rs->_nb_media[$rs->index()];
		}
		else
		{
			$strReq =
			'SELECT count(media_id) '.
			'FROM '.$rs->core->prefix.'post_media '.
			'WHERE post_id = '.(integer) $rs->post_id.' ';
			
			$res = (integer) $rs->core->con->select($strReq)->f(0);
			$rs->_nb_media[$rs->index()] = $res;
			
			$strReq =
			'SELECT count(media_id) '.
			'FROM '.$rs->core->prefix.'litraak_milestone_media MD '.
			'INNER JOIN '.$rs->core->prefix.'litraak_milestone M on M.milestone_id = MD.milestone_id '.
			'WHERE M.post_id = '.(integer) $rs->post_id.' ';
			
			$res = (integer) $rs->core->con->select($strReq)->f(0);
			$rs->_nb_media[$rs->index()] += $res;
			
			return $rs->_nb_media[$rs->index()];
		}
	}
	
	public static function hasNextRelease(&$rs)
	{
		return (!$rs->isEmpty() && $rs->exists('next_release_name') && $rs->next_release_name);
	}
	
	public static function hasLastRelease(&$rs)
	{
		return (!$rs->isEmpty() && $rs->exists('last_release_name') && $rs->last_release_name);
	}
	
	public static function getLastReleaseDate(&$rs,$format)
	{
		if ($format) {
			return dt::dt2str($format,$rs->last_release_dt);
		} else {
			return dt::dt2str($rs->core->blog->settings->date_format,$rs->last_release_dt);
		}
	}
	
	public static function getNextReleaseDate(&$rs,$format)
	{
		if ($format) {
			return dt::dt2str($format,$rs->next_release_dt);
		} else {
			return dt::dt2str($rs->core->blog->settings->date_format,$rs->next_release_dt);
		}
	}
	
	public static function isVisible(&$rs)
	{
		return 	(!$rs->isEmpty() && $rs->exists('post_status') && $rs->post_status != 0);
	}
}

class litraakExtMilestone
{
	public static function getDate(&$rs,$format)
	{
		if ($format) {
			return dt::dt2str($format,$rs->milestone_dt);
		} else {
			return dt::dt2str($rs->core->blog->settings->date_format,$rs->milestone_dt);
		}
	}
	
	public static function getTS(&$rs)
	{
		return strtotime($rs->milestone_dt);
	}
	
	public static function getISO8601Date(&$rs)
	{
		return dt::iso8601($rs->getTS(),$rs->milestone_tz);
	}
	
	public static function getRFC822Date(&$rs)
	{
		return dt::rfc822($rs->getTS(),$rs->milestone_tz);
	}
	
	public static function isReleased(&$rs)
	{
		return $rs->milestone_status == litraak::MILESTONE_RELEASED;
	}
	
	public static function countMedia(&$rs)
	{
		if (isset($rs->_nb_media[$rs->index()]))
		{
			return $rs->_nb_media[$rs->index()];
		}
		else
		{
			$strReq =
			'SELECT count(media_id) '.
			'FROM '.$rs->core->prefix.'litraak_milestone_media '.
			'WHERE milestone_id = '.(integer) $rs->milestone_id.' ';
			
			$res = (integer) $rs->core->con->select($strReq)->f(0);
			$rs->_nb_media[$rs->index()] = $res;
			return $res;
		}
	}
	
	public static function getProgress(&$rs)
	{
		$ratio = 0;
		$nb_tickets = (integer) $rs->milestone_nb_tickets - (integer) $rs->milestone_nb_wasted;
		$nb_done = $nb_tickets - (integer) $rs->milestone_nb_actives;
		if($nb_tickets > 0){
			$ratio = (integer) $nb_done / $nb_tickets;
		}
		if($ratio > 1) $ratio = 1;
		if($ratio < 0) $ratio = 0;
		
		return round($ratio * 100);
	}
	
	public static function getTicketNumber(&$rs, $type='')
	{
		switch($type){
			case 'actives': return (integer) $rs->milestone_nb_actives;
			case 'closed': return (integer) ($rs->milestone_nb_tickets - $rs->milestone_nb_wasted - $rs->milestone_nb_actives);
			case 'wasted': return $rs->milestone_nb_wasted;
			default: return (integer) $rs->milestone_nb_tickets;
		}
	}
}

class litraakExtTicket
{
	public static function getDate(&$rs,$format)
	{
		if ($format) {
			return dt::dt2str($format,$rs->ticket_upddt);
		} else {
			return dt::dt2str($rs->core->blog->settings->date_format,$rs->ticket_upddt);
		}
	}
	
	public static function getTS(&$rs)
	{
		return strtotime($rs->ticket_upddt);
	}
	
	public static function getISO8601Date(&$rs)
	{
		return dt::iso8601($rs->getTS(),$rs->ticket_tz);
	}
	
	public static function getRFC822Date(&$rs)
	{
		return dt::rfc822($rs->getTS(),$rs->ticket_tz);
	}
	
	public static function isType(&$rs, $type)
	{
		switch($type){
			case 'bug': return $rs->ticket_type == litraak::TICKET_BUG;
			case 'task': return $rs->ticket_type == litraak::TICKET_TASK;
			case 'idea': return $rs->ticket_type == litraak::TICKET_IDEA;
		}
		return false;
	}
	
	public static function isStatus(&$rs, $status)
	{
		switch($status){
			case 'new': return $rs->ticket_status == litraak::TICKET_NEW;
			case 'accepted': return $rs->ticket_status == litraak::TICKET_ACCEPTED;
			case 'closed': return $rs->ticket_status == litraak::TICKET_CLOSED;
			case 'rejected': return $rs->ticket_status == litraak::TICKET_REJECTED;
			case 'deleted': return $rs->ticket_status == litraak::TICKET_DELETED;
			case 'active': return $rs->ticket_status < litraak::TICKET_CLOSED;
		}
		return false;
	}
	
	public static function hasMilestone(&$rs)
	{
		return $rs->exists('milestone_id') && $rs->milestone_id > 0;
	}
}

class litraakExtTicketChange
{
	public static function getDate(&$rs,$format)
	{
		if ($format) {
			return dt::dt2str($format,$rs->change_dt);
		} else {
			return dt::dt2str($rs->core->blog->settings->date_format,$rs->change_dt);
		}
	}
	
	public static function getTS(&$rs)
	{
		return strtotime($rs->change_dt);
	}
	
	public static function getISO8601Date(&$rs)
	{
		return dt::iso8601($rs->getTS(),$rs->change_tz);
	}
	
	public static function getRFC822Date(&$rs)
	{
		return dt::rfc822($rs->getTS(),$rs->change_tz);
	}
	
	public static function getTitle(&$rs)
	{
		$litraak =& $GLOBALS['litraak'];
		
		eval('$res = '.$rs->change_title.';');
		return $res;
	}
	
	public static function getComment(&$rs)
	{
		return $rs->change_comment;
	}
	
	public static function hasComment(&$rs)
	{
		return $rs->change_comment != null;
	}
}
?>